/**
 *   @ingroup hal
 *   @file
 *
 *   SMI workaround for x86.
 *
 *   Cut/Pasted from Vitor Angelo "smi" module.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
 *   USA; either version 2 of the License, or (at your option) any later
 *   version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <rtai_config.h>

#ifdef __cplusplus
extern "C" {
#endif

#if CONFIG_RTAI_HW_SMI_DETECT && CONFIG_RTAI_HW_SMI_WORKAROUND

void rthal_smi_disable(void);

void rthal_smi_restore(void);

#else /* !CONFIG_RTAI_HW_SMI_DETECT || !CONFIG_RTAI_HW_SMI_WORKAROUND */

#define rthal_smi_disable()

#define rthal_smi_restore()

#endif /* !CONFIG_RTAI_HW_SMI_DETECT || !CONFIG_RTAI_HW_SMI_WORKAROUND */

#if CONFIG_RTAI_HW_SMI_DETECT

void rthal_smi_init(void);

#else /* !CONFIG_RTAI_HW_SMI_DETECT */

#define rthal_smi_init()

#endif /* !CONFIG_RTAI_HW_SMI_DETECT */

#ifdef __cplusplus
}
#endif
